/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : FunctionBag.h                                             */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include <stdio.h>
#include "FunctionBag.h"
#include "Function.h"
#include "../deffunc.h"

FunctionBag::FunctionBag()
{  myFunction = NULL;
   Index = 0;
}

FunctionBag::~FunctionBag()
{  if(Index) delete [] myFunction; }

float FunctionBag::getValue(float x) 
{  float maxi = 0.0;
   int i;

   for(i=0;i<Index;i++) maxi = maximum(maxi,(*myFunction[i]).getValue(x));

   return maxi;

}// end of getValue

void FunctionBag::addFunction(Function *newFunc) 
{  
   if(newFunc)
   {  Function **Temp = new Function*[Index+1];
      int i;

      for(i=0;i<Index;i++) Temp[i] = myFunction[i];
      Temp[i] = newFunc;
      if(Index) delete [] myFunction;
      Index++;
      myFunction = Temp;

   }// end of if

}// end of addFunction()

Function * FunctionBag::getFunctionWithIndx(int indx)
{  Function *ret = NULL;
   if(indx>=0&&indx<Index) ret = (*myFunction[indx]).getMyTwin();
   return ret;
}// end of getFunctionWithIndx()

Function * FunctionBag::Xversion()
{  FunctionBag *ret = new FunctionBag();
   
   for(int i=0;i<Index;i++) (*ret).addFunction((*myFunction[i]).Xversion());

   return ret;

}// end of Xversion()

Function * FunctionBag::getMyTwin()
{  FunctionBag *ret = new FunctionBag();
   
   for(int i=0;i<Index;i++) (*ret).addFunction((*myFunction[i]).getMyTwin());

   return ret;

}// end of getMyTwin()

int FunctionBag::getNumberOfFunctions() const {  return Index; }

ostream& operator<<(ostream& os, const FunctionBag& RHS)
{  RHS.printOn(os);
   return os;
}// end of operator<<()

void FunctionBag::printOn(ostream& os) const
{  os << " There are " << Index << " number of Functions " << endl; 
   for(int i=0;i<Index;i++) if(myFunction[i]) os << *myFunction[i] << endl;
}// end of printOn()

